package com.sun.jmx.mbeanserver;

import sun.reflect.misc.ReflectUtil;
import java.io.ObjectStreamClass;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;

class ObjectInputStreamWithLoader extends ObjectInputStream
{
    private ClassLoader loader;
    
    public ObjectInputStreamWithLoader(InputStream in, ClassLoader loader) throws IOException {
        super(in);
        this.loader = loader;
    }
    
    @Override
    protected Class<?> resolveClass(ObjectStreamClass desc) throws IOException, ClassNotFoundException {
        if (this.loader == null) {
            return super.resolveClass(desc);
        }
        String name = desc.getName();
        ReflectUtil.checkPackageAccess(name);
        return Class.forName(name, false, this.loader);
    }
}
